#include <cstdio>

const int MOD = 1'000'000'009;
int K, B;
struct QuotientAndRemainder {
	int q, r;
	int numOfMultiples() {
		return (q + (r >= 1)) % MOD;
	}
	QuotientAndRemainder multiply(int x) {
		QuotientAndRemainder ans;
		ans.q = ((long long)q * x) % MOD;
		ans.r = r * x;
		if (ans.r >= K) {
			ans.q = (ans.q + ans.r / K) % MOD;
			ans.r %= K;
		}
		return ans;
	}
}pow2qr[129]; // pow2qr[i] stores the quotient and the remainder when 2 to the power of i is divided by K
int pow2[129]; // pow2[i] is 2 to the power of i

void preprocess() {
	while ((K & 1) == 0)
		K >>= 1, --B;
	if (K > 1) {
		pow2qr[0].q = 0;
		pow2qr[0].r = 1;
	} else {
		pow2qr[0].q = 1;
		pow2qr[0].r = 0;
	}
	for (int i = 1; i <= 128; ++i)
		pow2qr[i] = pow2qr[i - 1].multiply(2);
	pow2[0] = 1;
	for (int i = 1; i <= 128; ++i)
		pow2[i] = (pow2[i - 1] << 1) % MOD;
}

int solve() {
	int ans = 0;
	for (int b = 1; b <= B; ++b) {
		// Pattern of the b-th position: 2 ^ (b - 1) zeros followed by 2 ^ (b - 1) ones, then repeat.
		// Observation: in K consecutive "2 ^ (b - 1) zeros followed by 2 ^ (b - 1) ones" (totally K * 2 ^ b bits),
		// among the K-th, (K * 2)-th, (K * 3)-th, ..., (K * 2^b)-th bit, exactly half of them is 1!
		for (int i = 1; i <= pow2qr[B - b].r; ++i) {
			ans = (ans + pow2qr[b - 1].multiply(2 * i).numOfMultiples()) % MOD;
			ans = (ans - pow2qr[b - 1].multiply(2 * i - 1).numOfMultiples() + MOD) % MOD;
		}
		ans = (ans + (long long)pow2qr[B - b].q * pow2[b - 1] % MOD) % MOD;
	}
	return ans;
}

int main() {
	scanf("%d%d", &K, &B);
	preprocess();
	printf("%d\n", solve());
	return 0;
}
